#include <sys/time.h>
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define TIME_DIFF(t1, t2) \
	((t2.tv_sec - t1.tv_sec) * 1000000 + (t2.tv_usec - t1.tv_usec))

#define N 4096
typedef float matrix[N][N] __attribute__((aligned(4096)));

matrix A,B,C;

void fillmatrix(matrix A) {
	int i,j;
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			A[i][j] = random();
}

void addmatrix(matrix A, matrix B, matrix C) {
	int i,j;
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			C[i][j] = cos(A[i][j]) + sin(B[i][j]);
}

float total;
void totalmatrix(matrix A) {
	int i,j;
	total = 0;
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			total += sin(A[i][j]);
}

/* pour le code parallle */
#define P 2

void *thread_function(void *param) {
	int numero = (intptr_t)param;

	/* ... */
	/* Travail du thread */
	/* ... */

	return NULL;
}

int main(void) {
	struct timeval tv1,tv2;

	fillmatrix(A);
	fillmatrix(B);
	fillmatrix(C);

	gettimeofday(&tv1,NULL);
	addmatrix(A,B,C);
	gettimeofday(&tv2,NULL);

	printf("%f ms\n", ((float)TIME_DIFF(tv1,tv2)) / 1000);

	return 0;
}
